<template>
  <div class="real-time-evaluation-page">
    <fks-row :gutter="10" style="width:100%;height:100%;">
        <fks-col :span="4" style="width:220px;height:100%">
            <div class="model-binding-left-box">
                <titleBox title="金刚沱泵站"></titleBox>
                    <fks-tree
                    ref="tree"
                    :data="treeData"
                    :props="defaultProps"
                    :show-icon="true"
                    default-expand-all
                    node-key="id"
                    current-node-key="1-2"
                    :highlight-current="true"
                    >
                    </fks-tree>
            </div>
        </fks-col>
        <fks-col :span="20" style="width:calc(100% - 220px);height:100%;">
            <div class="model-binding-right-box">
                <titleBox title="1#电机"></titleBox>
                <div class="top-box" style="width:100%;height:calc(100% - 40px)">
                    <div class="score-status-div">
                        <div id="scoreChart" class="score-chart-style"></div>
                        <div class="score-status-text" style="color:#70b603">正常状态</div>
                    </div>
                    <div class="table-box-style">
                        <fks-table 
                            border
                            max-height="500"
                            :data="TableData"
                            style="width: 100%;">
                            <fks-table-column
                                prop="evaluationItems"
                                label="评价项"
                                width="180">
                            </fks-table-column>
                            <fks-table-column
                                prop="Importance"
                                label="重要程度"
                                width="180">
                            </fks-table-column>
                            <fks-table-column
                                prop="SOH"
                                label="劣化程度">
                            </fks-table-column>
                            <fks-table-column
                                prop="penalty"
                                label="扣分">
                            </fks-table-column>
                            <fks-table-column
                                prop="evaluationResult"
                                label="评价结果">
                            </fks-table-column>
                    </fks-table>
                </div>
               </div>
            </div>
        </fks-col>
    </fks-row>
  </div>
</template>

<script>
import * as echarts from 'echarts';
import titleBox from "@/views/main/components/titleBox.vue"
let chartDom = ""
let myChart = ""
let option = ""
export default {
    components:{titleBox},
    data(){
        return {
            chartBoxHeight:0,
            tableHeight:0,
            treeData:[
                {
                    label: "金刚沱泵站",
                    id:'1',
                    children: [
                    {
                        id:'1',
                        label: "1#机组",
                        children:[
                            {
                            id:'1-1',
                            label: "1#泵",
                            },
                            {
                            id:'2-2',
                            label: "1#电机",
                            },
                        ],
                    },
                    {
                        id:'2',
                        label: "2#机组",
                        children:[
                            {
                            id:'2-1',
                            label: "2#泵",
                            },
                            {
                            id:'2-2',
                            label: "2#电机",
                            },
                        ],
                    },
                    {
                        id:'3',
                        label: "3#机组",
                        children:[
                            {
                            id:'3-1',
                            label: "3#泵",
                            },
                            {
                            id:'3-2',
                            label: "3#电机",
                            },
                        ],
                    },
                    {
                        id:'4',
                        label: "4#机组",
                        children:[
                            {
                            id:'4-1',
                            label: "4#泵",
                            },
                            {
                            id:'4-2',
                            label: "4#电机",
                            },
                        ],
                    },
                    ],
                },
            ],
            defaultProps: {
                children: "children",
                label: "label",
            },
            TableData:[
                {
                  evaluationItems:"有效值",
                  Importance:"1级",
                  SOH:"1级",
                  penalty:"5",
                  evaluationResult:"正常状态"
                },
                {
                  evaluationItems:"峭度",
                  Importance:"1级",
                  SOH:"1级",
                  penalty:"5",
                  evaluationResult:"正常状态"
                },
                {
                  evaluationItems:"峰值",
                  Importance:"1级",
                  SOH:"1级",
                  penalty:"5",
                  evaluationResult:"正常状态"
                },
                {
                  evaluationItems:"裕度",
                  Importance:"1级",
                  SOH:"1级",
                  penalty:"5",
                  evaluationResult:"正常状态"
                },
                {
                  evaluationItems:"波形",
                  Importance:"1级",
                  SOH:"1级",
                  penalty:"5",
                  evaluationResult:"正常状态"
                },
                {
                  evaluationItems:"有效值",
                  Importance:"1级",
                  SOH:"1级",
                  penalty:"5",
                  evaluationResult:"正常状态"
                },
                {
                  evaluationItems:"峭度",
                  Importance:"1级",
                  SOH:"1级",
                  penalty:"5",
                  evaluationResult:"正常状态"
                },
                {
                  evaluationItems:"峰值",
                  Importance:"1级",
                  SOH:"1级",
                  penalty:"5",
                  evaluationResult:"正常状态"
                },
                {
                  evaluationItems:"裕度",
                  Importance:"1级",
                  SOH:"1级",
                  penalty:"5",
                  evaluationResult:"正常状态"
                },
                {
                  evaluationItems:"波形",
                  Importance:"1级",
                  SOH:"1级",
                  penalty:"5",
                  evaluationResult:"正常状态"
                }
            ],
            showTableData:[]
        }
    },
    mounted(){
        let _this = this
        _this.showTableData = JSON.parse(JSON.stringify(_this.TableData))
           _this.$nextTick(()=>{
            _this.initChart()
        })

    window.addEventListener("resize", () => {
      setTimeout(() => {
        myChart && myChart.resize();
      }, 10);
    });
    },
    methods:{
        // 初始化chart
       initChart(){
            chartDom = document.getElementById('scoreChart')
            // chartDom.style.height = document.getElementsByClassName("score-status-div")[0].clientHeight + 'px'
            myChart = echarts.init(chartDom);
            option = {
                series: [
                    {
                    type: 'gauge',
                    startAngle: 180,
                    endAngle: 0,
                    center: ['50%', '75%'],
                    radius: '90%',
                    min: 0,
                    max: 1,
                    splitNumber: 8,
                    axisLine: {
                        lineStyle: {
                        width: 6,
                        color: [
                            [0.25, '#70b603'],
                            [0.5, '#facd91'],
                            [0.75, '#b8741a'],
                            [1, '#d9001b']
                        ]
                        }
                    },
                    pointer: {
                        icon: 'path://M12.8,0.7l12,40.1H0.7L12.8,0.7z',
                        length: '12%',
                        width: 20,
                        offsetCenter: [0, '-60%'],
                        itemStyle: {
                        color: 'inherit'
                        }
                    },
                    axisTick: {
                        length: 12,
                        lineStyle: {
                        color: 'inherit',
                        width: 2,
                        distance:10,
                        splitNumber:3
                        }
                    },
                    splitLine: {
                        length: 20,
                        lineStyle: {
                        color: 'inherit',
                        width: 2
                        }
                    },
                    axisLabel: {
                        color: '#464646',
                        fontSize: 14,
                        distance: -60,
                        rotate: 'tangential',
                        formatter: function (value) {
                        if (value === 0.875) {
                            return '严重';
                        } else if (value === 0.625) {
                            return '异常';
                        } else if (value === 0.375) {
                            return '注意';
                        } else if (value === 0.125) {
                            return '正常';
                        }
                        return '';
                        }
                    },
                    title: {
                        offsetCenter: [0, '-10%'],
                        fontSize: 20
                    },
                    detail: {
                        fontSize: 30,
                        offsetCenter: [0, '-35%'],
                        valueAnimation: true,
                        formatter: function (value) {
                        return Math.round(value * 100) + '';
                        },
                        color: 'inherit'
                    },
                    data: [
                        {
                        value: 0.2,
                        name: '扣分'
                        }
                    ]
                    }
                ]
};
option && myChart.setOption(option);
        },
    }
}
</script>

<style scoped>
.real-time-evaluation-page{
    width: 100%;
    height: calc(100% - 0px);
}
.model-binding-left-box{
    width: 100%;
    height: 100%;
    background: #fff;

}
.model-binding-right-box{
    width:100%;
    height: 100%;
    background: #fff;
}
.score-status-div{
    width: 100%;
    height: 30%;
    display: flex;
    justify-content: center;
    align-items: center;
}
.score-chart-style{
    width: 50%;
    height: 300px;
}
.score-status-text{
    width: 50%;
    height: 100%;
    font-size: 48px;
    font-weight: bold;
    display: flex;
    justify-content: center;
    align-items: center;
}
.table-box-style{
    width: 100%;
    height: 70%;
}
</style>